package org.wwbota.identification;
/** A Criterion associated to a single {@link Character}, e.g. "petal color is white or white and brown".
Criterion is called a state in <a href="http://biodiversity.uno.edu/delta/">Delta</a>, but it's not a defined state, it's a logical expression describing a set of individuals.
 */
public interface Criterion {
 // boolean matches(Description d);
 /** @return the probability that this Criterion corresponds to the given reference */
 double isCompatibleWith(Criterion reference);
 /** @return the associated {@link Character} object */
 Character getCharacter();
}
