package org.wwbota.identification;
import java.util.*;

/** The simplest type of a character  la Delta, a Character with String enumerated values ("multistate" in Delta), hence the name "EnumerationCharacter".  */
public class EnumerationCharacter implements Character {
 public EnumerationCharacter(String name){name_=name;}

 public boolean isPossibleState(Object state) {return possibleStates_.contains(state);}
 public void addPossibleState(String s) {possibleStates_.add(s);}
 public List getPossibleValues() {return new ArrayList(possibleStates_);}

 /** A factory for a Criterion of the type associated to the Character */
  public Criterion makeCriterion(String spec){
  return new ChoiceCriterion(this, spec);
 }
 class ChoiceCriterion implements Criterion{
  ChoiceCriterion(EnumerationCharacter c, String spec){
   character_ = c;
   choice_ = spec;
  }
  public double isCompatibleWith(Criterion reference){
   // if (((EnumerationCharacter)reference.getCharacter()).isPossibleState(choice_)) {
   if ( ((ChoiceCriterion)reference).choice_.equals(choice_) ) {
    return 1.;
   }
   return 0.;
  }
  public Character getCharacter(){
   return character_;
  }
  public String toString() {
   // return character_.getName() + " "+ choice_;
   return choice_;
  }
  private EnumerationCharacter character_;
  private String choice_;
 }

 public Class getType() {return String.class; }
 public String toString() {
  StringBuffer s = new StringBuffer(name_ + ": ");
  for (Iterator i = possibleStates_.iterator(); i.hasNext(); ) {
   s.append((String) i.next()+ ", ");
  }
  return s.toString();
 }
 public String getName() {return name_;}
 public String getURI (){return "http://wwbota.free.fr/Identification/EnumerationCharacter";}

 private Set possibleStates_ = new HashSet();
 private String name_;
}
