package org.wwbota.identification;
/** A General Property (e.g. color, shape). This allows to classify {@link Character} objects, and to add explicit semantics to the raw Delta-style characters.

Relationship between GeneralProperty and Character : a GeneralProperty is some kind of template Character, that is, it can not be used directly as a Character.
*/
public interface GeneralProperty extends Named {

  /** Factory for a Feature having this GeneralProperty and the given Organ.

For instance if the returned Feature is a subtype of {@link EnumerationCharacter}, to get a closed list of values you use EnumerationCharacter.getPossibleValues(); if such a list is not available it returns an empty list.

Since GeneralProperty is only an interface, the container of GeneralProperties will represent a context so that, for instance, the Possible Values returned will be different in different geographical or taxonomic contexts. */
 Feature createFeature(Organ organ);
}
