package org.wwbota.identification;
import java.util.*;

/** A Taxonomy is an aggregation of Descriptions of Taxa and Character objects */
public interface Taxonomy {
 /** Loads (or merge) a complete dataset from file (XDELTA or other format according to XML namespace) */
 void load(String fileName);
 /** @return a Map of {@link Character} objects; the key is the unique name for the Character.
So, using the Map API, you can use this to access the Character object by its name: <tt>(Character)myTaxonomy.getCharacters().get(name);</tt> */
 Map getCharacters();
 /** @return a Map of {@link Description} objects; the key is the unique name for the item (Taxon) being described */
 Map getDescriptions();
}
