package org.wwbota.identification;
import java.util.*;
import java.io.*;

 // sample to show use of the Identification API

 public class commandLineSample {
 public static void main ( String [] args ) {
  (new commandLineSample()) . doMain ( args );
 }
 public void doMain ( String [] args ) {
 Taxonomy t = new testSimpleTaxonomy();
 t.load("Trees_North_America.xml");
 SimpleIdentification d =  new SimpleIdentification(t);
 try {
  System.out.println( "DETERMINATION DATA");
  System.out.println( "TAXONOMY");
  System.out.println( d.getTaxonomy());

  // This is how we set things up to read lines of text from the user.
  BufferedReader in=new BufferedReader(new InputStreamReader(System.in));

  while (true) {
  System.out.println( "OBSERVATIONS");
  System.out.println( d.getDescription());

  List advices = d.getAdvices();
  if (advices.size()>0) {
   System.out.println("Print hints for adding more criteria:");
   for ( Iterator i = advices.iterator(); i.hasNext(); ) {
    Character c = (Character) i.next();
    System.out.println( "Character with possible values: " + c );
   }
  }
  System.out.print( "Enter Character name (or \"quit\")> " );
  String line = in.readLine();
  // If we reach the end-of-file, or if the user types "quit", then quit
  if ((line == null) || line.equals("quit")) break;
  String CharacterName = line;

  System.out.print( "Enter Character value> " );
  String CharacterValue = in.readLine();

  d.addCriterion((Character)t.getCharacters().get(CharacterName), CharacterValue);

  List matches = d.getMatches(); // getting the results
  int matchesCount = matches.size();

  {
    System.out.println( "RESULTS");
    System.out.println( "matches count: " + matchesCount); System.out.flush();
   // read results from start again ...
   for ( Iterator i = matches.iterator(); i.hasNext(); ) {
    System.out.println( i.next()); // printing a Description object, which is about a Taxon
   }
  }
  } // while (true)
  }
  catch (Exception e){ System.out.println(e);}
 }

 // This inner class is just here to simulate the reading of a data file
 class testSimpleTaxonomy extends SimpleTaxonomy {
  public void load(String fileName){
  try {
  String characterName = "leaf margin";
  EnumerationCharacter c_leaf_margin = new EnumerationCharacter(characterName);
  c_leaf_margin.addPossibleState( "entire");
  c_leaf_margin.addPossibleState( "lobed");
  c_leaf_margin.addPossibleState( "toothed");
  getCharacters().put(characterName, c_leaf_margin);

  characterName = "fruit type";
  EnumerationCharacter c_fruit_type = new EnumerationCharacter(characterName);
  c_fruit_type.addPossibleState( "berry");
  c_fruit_type.addPossibleState( "nut");
  getCharacters().put(characterName, c_fruit_type);

  characterName = "fruit size";
  RealNumberCharacter c_fruit_size = new RealNumberCharacter(characterName,"mm");
  getCharacters().put(characterName, c_fruit_size);

  //////////////////////

  String speciesName = "Fagus";
  Description d = new StandardDescription(new Genus(speciesName));
  d.addCriterion( c_leaf_margin.makeCriterion("entire"));
  d.addCriterion( c_fruit_type.makeCriterion("nut"));
  d.addCriterion( c_fruit_size.makeCriterion("10 15"));
  getDescriptions().put(speciesName, d);

  speciesName = "Quercus";
  d = new StandardDescription(new Genus(speciesName));
  d.addCriterion( c_leaf_margin.makeCriterion("lobed"));
  d.addCriterion( c_fruit_type.makeCriterion("nut"));
  d.addCriterion( c_fruit_size.makeCriterion("10 20"));
  getDescriptions().put(speciesName, d);

  speciesName = "Castanea";
  d = new StandardDescription(new Genus(speciesName));
  d.addCriterion( c_leaf_margin.makeCriterion("toothed"));
  d.addCriterion( c_fruit_type.makeCriterion("nut"));
  d.addCriterion( c_fruit_size.makeCriterion("30 40"));
  getDescriptions().put(speciesName, d);

  speciesName = "Sorbus";
  d = new StandardDescription(new Genus(speciesName));
  d.addCriterion( c_leaf_margin.makeCriterion("toothed"));
  d.addCriterion( c_fruit_type.makeCriterion("berry"));
  d.addCriterion( c_fruit_size.makeCriterion("5 15"));
  getDescriptions().put(speciesName, d);

  speciesName = "Nissa";
  d = new StandardDescription(new Genus(speciesName));
  d.addCriterion( c_leaf_margin.makeCriterion("entire"));
  d.addCriterion( c_fruit_type.makeCriterion("berry"));
  getDescriptions().put(speciesName, d);

  }
  catch (Exception e){System.out.println("load: "+e);}
 }
 }
}

